'* Demo code: 
Cls
Print @(12,12);
a$= LineEdit$("The Backshed")
Print
Print a$
End

 '*******************************************************
 '*
'*            LineEdit$ V.95
'*
'*          MMBasic 4.5/Maximite
'*
'*      by twofingers 09-2014 at TBS 
'* line editor for small strings (e.g. file names)
'* Tested with Duinomite in Monochrome mode.
'*--------------------------------------------------------------
'* Limit:
'* The string must not exceed the width of screen
'*
'* Supported keys:
'* left arrow, right arrow
'* Enter
'* ESC 
'* Home
'* End
'* Del
'* Ins
'* Backspace
'* all ASCII chars (char 32-126)
'* 
'*------------------------------------------------
'* Known issues (just to remember):
'* 1. EXIT from do:loop
'*    workaround: Flag (enterPressed)
'*    in LineEdit$
'*    seems to be a bug??
'* 2. keydown without waitstates
'*    workaround: 200ms pause
'*    in LineEdit$
'*    seems to be a bug?
'*
'*  possible improvments: 
'*  a fixed minimum string size
'*  color modes
'*******************************************************
' This code may be freely distributed and
' changed. Provided AS IS without any warranty.
' Use it at your own risk.
 '*******************************************************
Function LineEdit$ edText$
Local hpos, vpos, p, ep, keyvalue, enterPressed
Local text$,ltext$,mtext$,rtext$
Local TRUE, FALSE
Local insertMode

  TRUE =1
  FALSE=0
  hpos=MM.HPos:vpos=MM.VPos ' save print position
  text$=edText$             ' use local copy of edtext$ parameter 
  LineEdit$=edText$         ' backup edText$ for Esc  
  p=Len(text$)              ' cursor pointer
  ep=p                      ' end pointer
  shift$=" "                ' out shift buffer
  enterPressed=FALSE        ' Flag to EXIT the loop
  insertMode=FALSE

  Pause 200 ' es gibt einen Zeitfaktor fuer keyboard input buffer ~140ms

  Print @(hpos,vpos)Left$(text$,p-1);
  Font#1,,1:Print Right$(text$,1);:Font#1

  Do
    Do:keyvalue=KeyDown:Pause 20:Loop While keyvalue=0

    If keyvalue=130 And p>1   Then p=p-1  'left arrow
    If keyvalue=131 And p<ep Then p=p+1   'right arrow
    If keyvalue=13 Then
       enterPressed=TRUE                  'Enter
    EndIf
    If keyvalue=27 Then
       Print @(hpos,vpos)LineEdit$;
       Exit Function                      'ESC
    EndIf
    If keyvalue=134 Then p=1              'Home
    If keyvalue=135 Then p=ep             'End
    If keyvalue=132 Then
       insertMode=Not insertMode          'Insert toggle
    EndIf
    If keyvalue>=32 And keyvalue<127 Then 'all ASCII chars
      If insertMode And Len(shift$) <255 Then
        If p<ep Then
          p=p+1
          ltext$=ltext$+Chr$(keyvalue)
          mtext$=""
          rtext$=Mid$(text$,p-1,ep-p+1)
        Else
          ltext$=Left$(text$,p-1)+Chr$(keyvalue)
          mtext$=""
          rtext$=""
        EndIf
        shift$=Right$(text$,1)+shift$
      Else
        If p<ep Then
          p=p+1
          ltext$=ltext$+Chr$(keyvalue)
          mtext$=Mid$(text$,p,1)
          rtext$=Mid$(text$,p+1)
        Else
          ltext$=Left$(text$,p-1)
          mtext$=Chr$(keyvalue)
          rtext$=""
        EndIf
      EndIf
    ElseIf keyvalue=8 And p>1 Then        'Backspace
      If insertMode Then
        p=p-1
        ltext$=Mid$(text$,1,p-1)
        mtext$=""
        rtext$=Mid$(text$,p+1)+Left$(shift$,1)
        shift$=Mid$(shift$,2)
      Else
        p=p-1
        ltext$=Mid$(text$,1,p-1)
        mtext$=Mid$(text$,p+1,1)
        rtext$=Mid$(text$,p+2)+Left$(shift$,1)
        shift$=Mid$(shift$,2)
      EndIf
    ElseIf keyvalue=127 Then              'Del
        ltext$=Mid$(text$,1,p-1)
        mtext$=Mid$(text$,p+1,1)
        rtext$=Mid$(text$,p+2)+Left$(shift$,1)
        shift$=Mid$(shift$,2)
    Else
      If insertMode Then
        ltext$=Mid$(text$,1,p-1)          'move cursor / insert mode
        mtext$=""
        rtext$=Mid$(text$,p,ep-p+1)
      Else
        ltext$=Mid$(text$,1,p-1)          'move cursor / over write
        mtext$=Mid$(text$,p,1)
        rtext$=Mid$(text$,p+1,ep-p)
      EndIf
    EndIf

    Print @(hpos,vpos)ltext$;
    Font#1,,Not insertMode
    Print mtext$;
    Font#1
    Print rtext$;

    If insertMode Then                   ' show the insert cursor
      Line (hpos+p*6-7,vpos)-(hpos+p*6-7+1,vpos+9),-1,BF
    EndIf
    
    text$=Left$(ltext$+mtext$+rtext$,ep)
    If shift$="" Then shift$=" "

    Pause 120 ' some wait states to slow down key input
  Loop While Not enterPressed
  LineEdit$=ltext$+mtext$+rtext$
  Print @(hpos,vpos)LineEdit$;
End Function
'*****************************************************
